;==========================================================================
;  Anwendung:		Kopierprogram fr RAM und ROM
;
;	Autor:			E.Mueller
;
;	erstellt:		?
;	gendert:		22.03.2008
;       
;	Prozessor:		U883
;	Takt:				8 MHz
;	geeignet fr:	JU+TE mit 4K Betriebssystem
;
;==========================================================================

	.org %3000

Anfang:
	push	rp
	srp	#%40
	ld	r15,#low	Z_Bild1
	ld	r14,#high Z_Bild1
	call	Baue_Bild
	;Kopierziel wirklich im RAM? (ab %8000)
	tcm	%28,#%80
	jr	Z,$F
	ld	r15,#low	Z_Bild3
	ld	r14,#high Z_Bild3
	call	Baue_Bild
	ld	r15,#low	Z_Bild5
	ld	r14,#high Z_Bild5
	call	Baue_Bild
	pop	rp
	call	%0C1D	;Tastenabfrage
	jr	Anfang	
$$	pop	rp
	call	%0C1D	;Tastenabfrage
	ld	%22,%5A
	cp	%22,#%4A	;J
	jr	Z,Kop_start
	pop	rp
	ret

Kop_start:
	di				;Los gehts
	push rp
	srp #%20
	incw	rr6		;Damit auch die letzte Postion kopiert wird !
starten:
	ldc r0,@rr4
	lde @rr8,r0
	;Alles i.O.?
	push	r1
	ldc	r1,@rr8
	cp	r1,r0
	jr	z,$F
	;Fehler bei Kopieren
	pop	r1
	pop rp
	ei
	push	rp
	srp	#%40
	ld	r15,#low	Z_Bild4
	ld	r14,#high Z_Bild4
	call	Baue_Bild
	ld	r15,#low	Z_Bild5
	ld	r14,#high Z_Bild5
	call	Baue_Bild
	pop	rp
	call	%0C1D	;Tastenabfrage
	jp	Anfang
$$	pop	r1
	incw rr4
	incw rr8
	cp r6,r4
	jr nz,starten	;oberer Teil nicht 0, dann weiter
	cp r7,r5
	jr nz,starten	;unterer Teil nicht 0, dann weiter
	pop rp
	ei
	push	rp
	srp	#%40
	ld	r15,#low	Z_Bild2
	ld	r14,#high Z_Bild2
	call	Baue_Bild
	pop	rp
	call	%0C1D	;Tastenabfrage
	ld	%22,%5A
	cp	%22,#%4A	;J
	jp	Z,Anfang	
	ret

Baue_Bild:
	ldc	r13,@rr14
	cp	r13,#%01
	jr	z,BB_W1
	cp	r13,#%02
	jr	z,BB_W2
	cp	r13,#%03
	jr	z,BB_W3
	cp	r13,#%04
	jr	z,BB_W4
	cp	r13,#%05
	jr	z,BB_W5
	cp	r13,#%06
	jr	z,BB_WX
	;normales Zeichen
	ld	%5A,r13
	call	%0827
BB_W0:
	incw	rr14	
	jr	Baue_Bild
BB_W1:
	call	%08DD	;Bildschirm lschen
	jr		BB_W0
BB_W2:
	call	%0ACE	;neue Zeile
	jr		BB_W0
BB_W3:
	ld	%2A,#%24	;Quelle von
	call	Adresse_eingeben
	jr		BB_W0
BB_W4:
	ld	%2A,#%26	;Quelle bis
	call	Adresse_eingeben
	jr		BB_W0
BB_W5:
	ld	%2A,#%28	;Ziel von
	call	Adresse_eingeben
	jr		BB_W0
BB_WX:
	ret

Z_Bild1:	
	;%01 Bildschirm lschen
	;%02 neue Zeile
	;%03 Quelle von
	;%04 Quelle bis
	;%05 Ziel von
	;%06 Ende
	db	%01
	.ascii "RAM-KOPIERER"
	db	%02,%02
	.ascii "QUELLE"
	db	%02
	.ascii "VON: "
	db %03,%02
	.ascii "BIS: "
	db %04,%02
	.ascii "ZIEL"
	db	%02
	.ascii "VON: "
	db %05,%02
	.ascii "BEREIT(J/N)?"
	db	%06

Z_Bild2:	
	db	%01
	.ascii "  KOPIEREN"
	db %02
	.ascii "   FERTIG!"
	db %02, %02
	.ascii "NOCHMAL(J/N)?"
	db %06

Z_Bild3:	
	db	%01
	.ascii " ZIEL LIEGT"
	db %02
	.ascii "NICHT IM RAM"
	db %02
	.ascii " AB ADRESSE"
	db %02
	.ascii " %8000 (HEX)"
	db %06

Z_Bild4:	
	db	%01
	.ascii " FEHLER BEIM"
	db %02
	.ascii "  KOPIEREN!"
	db %06
	
Z_Bild5:
	db %02,%02
	.ascii "  BELIEBIGE"
	db %02
	.ascii "    TASTE"
	db %02
	.ascii "  DRUECKEN!"
	db %06
	
Taste_erkannt:
	ld	%5A,%22		;Darstellen	
	call	%0827
	ld	@%2F,%20	;Lade Zeichen in Zwischenspeicher
	dec	%2F			;Stellenzeiger Zwischenspeicher
	djnz	r3,Tastenabfrage
	rl	%2E	;1.Stelle
	rl	%2E
	rl	%2E
	rl	%2E
	and	%2E,#%F0
	rl	%2C	;3.Stelle
	rl	%2C
	rl	%2C
	rl	%2C
	and	%2C,#%F0
	add	%2E,%2D	;1.& 2.Stelle zusammenfhren
	add	%2C,%2B	;3.& 4.Stelle zusammenfhren
	ld	@%2A,%2E	;oberer Adressteil
	inc	%2A
	ld	@%2A,%2C	;unterer Adressteil
	pop	rp
	ret	

Adresse_eingeben:
	push	rp
	srp	#%20
	ld	%23,#%04		;Stellenzhler auf 4
	ld	%2F,#%2E		;Stellenzeiger
Tastenabfrage:
	call	%0C1D	;Tastenabfrage
	ld	%22,%5A
	ld	%20,#%00
	cp	%22,#%30	;0
	jp	Z,Taste_erkannt
	ld	%20,#%01
	cp	%22,#%31	;1
	jp	Z,Taste_erkannt
	ld	%20,#%02
	cp	%22,#%32	;2
	jp	Z,Taste_erkannt
	ld	%20,#%03
	cp	%22,#%33	;3
	jp	Z,Taste_erkannt
	ld	%20,#%04
	cp	%22,#%34	;4
	jp	Z,Taste_erkannt
	ld	%20,#%05
	cp	%22,#%35	;5
	jp	Z,Taste_erkannt
	ld	%20,#%06
	cp	%22,#%36	;6
	jp	Z,Taste_erkannt
	ld	%20,#%07
	cp	%22,#%37	;7
	jp	Z,Taste_erkannt
	ld	%20,#%08
	cp	%22,#%38	;8
	jp	Z,Taste_erkannt
	ld	%20,#%09
	cp	%22,#%39	;9
	jp	Z,Taste_erkannt
	ld	%20,#%0A
	cp	%22,#%41	;A
	jp	Z,Taste_erkannt
	ld	%20,#%0B
	cp	%22,#%42	;B
	jp	Z,Taste_erkannt
	ld	%20,#%0C
	cp	%22,#%43	;C
	jp	Z,Taste_erkannt
	ld	%20,#%0D
	cp	%22,#%44	;D
	jp	Z,Taste_erkannt
	ld	%20,#%0E
	cp	%22,#%45	;E
	jp	Z,Taste_erkannt
	ld	%20,#%0F
	cp	%22,#%46	;F
	jp	Z,Taste_erkannt
	jp	Tastenabfrage

.end
